<?php
require_once "./lib/nusoap.php";
/**
	Plugin Name: ePayBank for EDD
	Version: 1.7
	Description: این افزونه درگاه <a href="https://epaybank.ir/" target="_blank">ePayBank.ir</a> را به افزونه Easy Digital Downloads اضافه می&zwnj;کند. این افزونه با نسخه 1.4.4.1 پارسی سازگار است.
	
	Author: Morteza Saheb
	Author URI: http://ariacoders.com
**/
@session_start();

function edd_rial ($formatted, $currency, $price) {
	return $price . ' ریال';
}
add_filter( 'edd_rial_currency_filter_after', 'edd_rial', 10, 3 );

function pl_add_gateway ($gateways) {
	$gateways['ePayBank'] = array('admin_label' => 'ePayBank', 'checkout_label' => 'Online Payment with ePayBank.ir');
	return $gateways;
}
add_filter( 'edd_payment_gateways', 'pl_add_gateway' );

function pl_cc_form () {
	do_action( 'pl_cc_form_action' );
}
add_filter( 'edd_ePayBank_cc_form', 'pl_cc_form' );

function pl_process_payment ($purchase_data) {
	global $edd_options;
	
	//if (!edd_is_test_mode()) {
		
		$api = $edd_options['ePayBank_api'];
//}

	
	$payment_data = array( 
		'price' => $purchase_data['price'], 
		'date' => $purchase_data['date'], 
		'user_email' => $purchase_data['post_data']['edd_email'],
		'purchase_key' => $purchase_data['purchase_key'],
		'currency' => $edd_options['currency'],
		'downloads' => $purchase_data['downloads'],
		'cart_details' => $purchase_data['cart_details'],
		'user_info' => $purchase_data['user_info'],
		'status' => 'pending'
	);
	$payment = edd_insert_payment($payment_data);
	
	if ($payment) {
		$_SESSION['ePayBank_payment'] = $payment;
		$return = urlencode(add_query_arg('order', 'ePayBank', get_permalink($edd_options['success_page'])));
		$price = $payment_data['price'];
$_SESSION['ePayBank_price'] = $price;
		$orderid=date('ymdhis');
		$gateway="parsian";


//===============================================================================================================
$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("requestpayment",array($api,$return,$price,$gateway,$orderid));
$client->soap_defencoding = 'UTF-8';
if($client->fault){
	echo "<h2>Fault</h2><pre>";
	print_r($result);
	echo "</pre>";
}
else
{
$error=$client->getError();
	if($error)
	{
		echo "<h2>Error</h2><pre>".$error."</pre>";
	}
	else
	{
		
		//echo "<script>window.location='".."';</script>";
		wp_redirect($result);
		
	}
}
//================================================================================================================		
		
		exit;
	} else {
		edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
	}
}
add_action('edd_gateway_ePayBank', 'pl_process_payment');

function pl_verify() {
	global $edd_options;
	if (isset($_GET['order']) and $_GET['order'] == 'ePayBank' and $_POST['id_get'] and $_POST['trans_id']) {
		$payment = $_SESSION['ePayBank_payment'];
		//if (!edd_is_test_mode()) {
			
			$api = $edd_options['ePayBank_api'];
		//}
		
		
		
//=========================================================================
$price=$_SESSION['ePayBank_price'];
$value=trim($price);
$rs=$_GET['rs'];
if(preg_match('/^[0-9]*$/',$value))
{
$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
$client->soap_defencoding = 'UTF-8';

$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("verifypeyment",array($api,$value,$rs,$_SESSION["bank"]));
$client->soap_defencoding = 'UTF-8';

if($client->fault){
	echo "<h2>Fault</h2><pre>";
	print_r($result);
	echo "</pre>";
}
else
{
$error=$client->getError();
	if($error){
		echo "<h2>Error</h2><pre>".$error."</pre>";
	}
	else
	{
		edd_empty_cart();
		if($result=='-33')
		{
		edd_update_payment_status($payment, 'publish');
		edd_send_to_success_page();
		echo "<br/>"."کد رسید تراکنش شما" .$rs;
		}
		else
		{
		edd_update_payment_status($payment, 'failed');
			$failed_page = get_permalink($edd_options['failure_page']);
			wp_redirect( $failed_page );
			exit;
		}
	}
}
}//if first
//=========================================================================		
		
		


		
	}
}
add_action('init', 'pl_verify');

function pl_add_settings ($settings) {
	$ePayBank_settings = array (
		array (
			'id'		=>	'ePayBank_settings',
			'name'		=>	'<strong>Configuration of ePayBank</strong>',
			'desc'		=>	'تنظیمات پیکر بندی فروشگاه با درگاه پرداخت',
			'type'		=>	'header'
		),
		array (
			'id'		=>	'ePayBank_api',
			'name'		=>	'کلید API',
			'desc'		=>	'کد پذیرندگی خود را کافیست در این بخش درج نمایید',
			'type'		=>	'text',
			'size'		=>	'regular'
		)
	);
	return array_merge( $settings, $ePayBank_settings );
}
add_filter('edd_settings_gateways', 'pl_add_settings');
?>
